# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.


from basesoft.web.core.util.db import DatabaseSession
from sqlalchemy.sql.expression import and_
from we.product.controllers import WeProductController
from we.product.models import WeTbsProductLevel, WeTbsRegulationPeriodProduct
from we.tbs.models import WeTbsRegulationPeriod, WeTbsLicense

if __name__ == "__main__":
    sa_session = DatabaseSession().Session

    # get all TBSes
    c = WeProductController(sa_session)
    tbses = sa_session.query(WeTbsLicense)

    for tbs in tbses:
        # get RP per TBS
        rp = sa_session.query(WeTbsRegulationPeriod).filter(WeTbsRegulationPeriod.tbs == tbs).all()

        # if more than 1 RP continue
        if len(rp) > 1:
            continue

        rp = rp.pop()

        # get all categories in RP
        product_levels = sa_session.query(WeTbsProductLevel).join(WeTbsRegulationPeriodProduct)\
            .filter(WeTbsRegulationPeriodProduct.tbs_regulation_period_id == rp.id).all()

        # order categories
        product_levels = c._order_tbs_product_levels(product_levels)

        # update RPP position
        p = 1
        for pl in product_levels:
            rpp = sa_session.query(WeTbsRegulationPeriodProduct).filter(
                and_(
                    WeTbsRegulationPeriodProduct.tbs_product_level == pl,
                    WeTbsRegulationPeriodProduct.tbs_regulation_period == rp,
                )
            ).first()

            if rpp is None:
                continue
            rpp.position = p
            sa_session.add(rpp)
            p += 1
    sa_session.flush()
