# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.

"""
#627: This update script is used to grant proper privileges on Orders PRIV_EXPORT for operator
"""

import sys
import traceback

from basesoft.web.core.util.controllers import AbstractController
from basesoft.web.core.util.db import DatabaseSession

from we.core.models import WeOperatorLicense
from we.order.models import WeDeclarationOrder

sa_session = DatabaseSession().Session


def grant_privileges():
    c = AbstractController(sa_session)

    operator_group_ids = [x.default_group.id for x in sa_session.query(WeOperatorLicense).all()]
    print 'operator_group_ids: %s' % operator_group_ids
    assert len(operator_group_ids) > 0

    for order in sa_session.query(WeDeclarationOrder):
        print 'Processing WeDeclarationOrder: %d' % order.id

        for order_group in order.groups:
            if order_group.group.id not in operator_group_ids:
                continue

            if not c.has_privileges_on_object(order, WeDeclarationOrder.PRIV_EXPORT, groups=[order_group.group]):

                c.grant_privilege_to(order, WeDeclarationOrder.PRIV_EXPORT, license=True,
                                     target_group=order_group.group, check_own_privs=False)
                print 'added PRIV_EXPORT to order/group %s/%s' % (order.id, order_group.group.id)

if __name__ == "__main__":
    sa_session.begin()
    try:
        grant_privileges()
        sa_session.commit()
    except Exception, e:

        traceback.print_exc(file=sys.stdout)

        sa_session.rollback()
        raise e

