'''
Created on Oct 10, 2014

@author: rado
'''
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.iconbar.models import IconBarIcon
from basesoft.web.contrib.account.decorators import assert_user_logged_in

class WeMemberWizardIcon(IconBarIcon):

    id = 'icon-we-member-wizard'
    title = _('New producer wizard')
    icon_index = 2
    component = 'we_member_wizard'
    group = 'we_member'
    group_title = _('Producer management')
    colorname = 'iconbar-green-smoke'

    char_main = u'\uE814' # Arrows recycle icon
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('we_create_member_license')

class WeMemberManagerIcon(IconBarIcon):

    id = 'icon-we-member-manager'
    title = _('Producer overview')
    icon_index = 1
    component = 'we_member_manager'
    group = 'we_member'
    group_title = _('Producer management')
    colorname = 'iconbar-green-smoke'

    char_main = u'\uE814' # Arrows recycle icon
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('we_view_member_license')

class WeLppMasterDataManagerIcon(IconBarIcon):

    id = 'icon-we-lpp-master-data-manager'
    title = _('LPP master data overview')
    icon_index = 2
    component = 'we_lpp_master_data_manager'
    group = 'we_member'
    group_title = _('Producer management')
    colorname = 'iconbar-green-smoke'

    char_main = u'\uE814' # Arrows recycle icon
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('we_view_lpp_companies')

def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """

    return [
        WeMemberManagerIcon(),
        WeMemberWizardIcon(),
        WeLppMasterDataManagerIcon(),
    ]
