'''
Created on Dec 16, 2014

@author: marten
'''


from basesoft.web.contrib.contact.models import Company, Contact
from basesoft.web.contrib.license.models import License
from basesoft.web.contrib.account.models import Account
from django.utils.translation import ugettext_lazy as _


class WeMemberAccount(Account):
    """
    @DynamicAttrs
    """
    permissions = ['we_create_member_license', 'view_all_domains']  # DISABLED UNTIL FURTHER NOTICE

    NAME_I18N = _('WE local producer account')

class WeMemberAccountLpp(object):
    """
    @DynamicAttrs
    """
    pass

class WeHqppLicense(License):
    """
    @DynamicAttrs
    """
    REQUIRED_PERMISSIONS = ('we_create_member_license', )
    NAME_I18N = _("WE HQPP License")

    def __get_controller(self):
        from we.member.controllers import WeMemberController
        return WeMemberController

class WeLpp(object):
    """
    @DynamicAttrs
    """
    STATUS_NEW = 0 # newly created
    STATUS_PENDING = 1 # queried at TBS
    STATUS_ACTIVE = 2 # master data retrieved from TBS and ready for declarations
    STATUS_INACTIVE = 3 # No longer an active LPP.

    def __repr__(self):
        return '<WeLpp id=%s name=%s>' % (self.id, self.name)


class WeCompany(Company):
    """
    @DynamicAttrs
    """
    NAME_I18N = _('WEEE-EU company')
    STR = 'WeCompany'

    def __repr__(self):
        return '<WeCompany id=%s>' % self.id


class WeContact(Contact):
    # This is used for company validation/privilege checks.
    company_instance_class = WeCompany

    NAME_I18N = _('WEEE-EU Contact')
    PERMISSIONS = ('we_view_lpp_companies', )
    STR = 'WeContact'
