# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon


class WeDeclarationOrderManagerIcon(IconBarIcon):

    id = 'icon-we-declaration-order-manager'
    title = _('Declaration order overview')
    icon_index = 2
    component = 'we_declaration_order_manager'
    group = 'we_declaration'
    group_title = _('Declarations')
    colorname = 'iconbar-cerulean'

    char_main = u'\uE814'  # Arrows recycle icon
    char_sub = u'\uE810'  # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('we_view_declaration_order')


def get_icons():
    return [WeDeclarationOrderManagerIcon(), ]
