# Copyright (c) 2014 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController
from django.utils.translation import ugettext_lazy as _
from basesoft.util.ordered_dict import OrderedDict

class WeCN8WeeeProductLevelWidget(DashboardWidgetCQStateController):
    """
    Weee CN8 code Overview Widget
    """
    label = _('WEEE CN8 UNU code overview')
    name = 'we_cn8_weee_product_level_widget'
    category = _('Product management')
    permissions = ['we_manage_cn8']
    classname = 'palette_group__menu--manager'

class WeTbsPriceSheetWidget(DashboardWidgetCQStateController):
    """
    TBS Local Category Overview Widget
    """
    label = _('TBS local categories & fees')
    name = 'we_tbs_price_sheet_widget'
    category = _('TBS management')
    permissions = ['we_view_tbs_product_level']
    classname = 'palette_group__menu--manager'


class WeHqppProductWidget(DashboardWidgetCQStateController):
    """
    Weee Hqpp Product Overview Widget
    """
    label = _('Producer product portfolio')
    name = 'we_hqpp_product_widget'
    category = _('Producer management')
    permissions = ['we_view_products']
    classname = 'palette_group__menu--manager'

class WeHqppProductFeeOverviewWidget(DashboardWidgetCQStateController):
    """
    Weee Hqpp Product Overview Widget
    """
    label = _('Producer product fee overview')
    name = 'we_hqpp_product_fee_overview_widget'
    category = _('Producer management')
    permissions = ['we_view_products']
    classname = 'palette_group__menu--manager'

class WeCN8PeriodProductWidget(DashboardWidgetCQStateController):
    """
    CN8 - TBS Local Category links Overview Widget
    """
    label = _('CN8 - Local category links overview')
    name = 'we_cn8_tbs_product_level_widget'
    category = _('TBS management')
    permissions = ['we_manage_cn8_tbs_product_level']
    classname = 'palette_group__menu--manager'


widgets_mapper = OrderedDict([
    ('WeCN8WeeeProductLevelWidget', WeCN8WeeeProductLevelWidget),
    ('WeTbsPriceSheetWidget', WeTbsPriceSheetWidget),
    ('WeHqppProductWidget', WeHqppProductWidget),
    ('WeCN8PeriodProductWidget', WeCN8PeriodProductWidget),
    ('WeHqppProductFeeOverviewWidget', WeHqppProductFeeOverviewWidget),
])
