'''
Created on Dec 17, 2014

@author: marten
'''
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.iconbar.models import IconBarIcon
from basesoft.web.contrib.account.decorators import assert_user_logged_in

class WeTbsManagerIcon(IconBarIcon):

    id = 'icon-we-tbs-manager'
    title = _('TBS overview')
    component = 'we_tbs_manager'
    group = 'tbs'
    group_title = _('TBS management')
    colorname = 'iconbar-clay-creek'

    char_main = u'\uE814' # Arrows recycle icon
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('we_tbs_license')

def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """
    return [
        WeTbsManagerIcon(),
    ]