'''
Created on Dec 16, 2014

@author: marten
'''
from basesoft.web.contrib.license.models import License
from django.utils.translation import ugettext_lazy as _

class WeTbsLicense(License):
    """
    @DynamicAttrs
    """
    DECLARATION_PERIOD_MONTHLY = 1
    DECLARATION_PERIOD_QUARTERLY = 2
    DECLARATION_PERIOD_BIANNUALLY = 3
    DECLARATION_PERIOD_YEARLY = 4

    REQUIRED_PERMISSIONS = ('we_tbs_license', )
    NAME_I18N = _("WE TBS License")

    def __repr__(self):
        return '<WeTbsLicense id=%d>' % self.id

class WeTbsRegulationPeriod(object):
    """
    @DynamicAttrs
    """

    WEIGHT_PER_UNIT = pow(2, 0)
    WEIGHT_CATEGORY_1 = pow(2, 1)
    WEIGHT_CATEGORY_2 = pow(2, 2)
    WEIGHT_CATEGORY_3 = pow(2, 3)
    WEIGHT_CATEGORY_4 = pow(2, 4)
    WEIGHT_CATEGORY_5 = pow(2, 5)
    WEIGHT_DOCUMENTATION = pow(2, 6)
    WEIGHT_BATTERIES = pow(2, 7)
    WEIGHT_PACKAGING = pow(2, 8)

    def _get_title(self):
        return "%s (%s %d)" % (self.label, self.start_date.strftime("%B"), self.start_date.year)

    def __repr__(self):
        return "<WeTbsRegulationPeriod id=%s tbs_id=%s>" % (self.id, self.tbs_id)

    title = property(_get_title)
